#include "StdAfx.h"
#include "WASListNotice.h"
#include "ConvertUTF.h"
#include "MessengerActor.h"
#include "UtilFunction.h"
#include "GameTalkAPIGlobal.h"

CWASListNotice::CWASListNotice(CWASActor *pActor) : CWASCommand(pActor)
{
}

CWASListNotice::~CWASListNotice(void)
{
}


//////////////////////////////////////
void CWASListNotice::ExecuteAsync()
{
	m_listNoticeData.clear();		//  Ʈ	

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return;
	}	

	USES_UTF8_CONVERSION;

	WSTRING strURL = m_pActor->GetWASServerAddress();
	strURL +=  _T("/ne/notice/ListNotice.php");

	WSTRING strUserID = (WCHAR*)pMessengerActor->GetUserID();	
	int nAtPos = strUserID.find(_T("@"));
	int nDotPos = strUserID.find(_T("."));	
	
	WSTRING strDomain = strUserID.substr(nAtPos + 1, nDotPos - 1 - nAtPos);
	WSTRING strTenant = strUserID.substr(nDotPos + 1, strUserID.size());

	m_httpFacade.StopRequest();
	m_httpFacade.session().SetURL( W2U8(strURL.c_str()), pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().SetMethod(HTTP_METHOD_POST);

	m_httpFacade.session().AddBodyVariable("userid", W2U8(pMessengerActor->GetUserID()));	
	m_httpFacade.session().AddBodyVariable("ticket", pMessengerActor->GetMessengerTicket());
	m_httpFacade.session().AddBodyVariable("tenant", W2U8(strTenant.c_str()));
	m_httpFacade.session().AddBodyVariable("domain", W2U8(strDomain.c_str()));

	m_httpFacade.session().SetKeepRawHeader(TRUE);
	m_httpFacade.SendRequest(this);
}


bool CWASListNotice::ParseAndEventFire(nfc::CIkXMLDom * pDom)
{
	if(pDom == NULL)
		return false;

	CMessengerActor *pMessengerActor = static_cast<CMessengerActor *>(m_pActor->GetMessengerActor());
	if(pMessengerActor == NULL)
	{
		return false;
	}	

	USES_UTF8_CONVERSION;

	do
	{
		nfc::IIkXMLNode * pRootNode = pDom->GetdocumentElement()->selectSingleNode("nodes");
		nfc::IIkXMLNodeList *pNodeList;
		nfc::IIkXMLNode * pListNode;
		nfc::IIkXMLAttribute * pAttr;		

		pNodeList = pRootNode->selectNodes("node");

		// Tree Re-Construction
		
		for(int j = 0; j < pNodeList->Getlength(); j++)
		{
			NE_NOTICE_DATA noticeData;
			memset(&noticeData, 0x00, sizeof(NE_NOTICE_DATA));
			pListNode = pNodeList->Getitem(j);

			pAttr = pListNode->getAttribute("seq");
			if(NULL == pAttr) continue;
			noticeData.nSeq = atoi(pAttr->Gettext().c_str());

			pAttr = pListNode->getAttribute("title");
			if(NULL == pAttr) continue;
			noticeData.strTitle = U82W(pAttr->Gettext().c_str());

			m_listNoticeData.push_back(noticeData);				
		}

	} while(FALSE);

	return true;
}


// override in drived class
void CWASListNotice::OnWasResponse(trid_t trid,
								  bool bSuccess,
								  int /*nWinINetErrorCode*/, 
								  int /*nHttpResponseCode*/, 
                                  LPCSTR /*szWasResCodeInHeader*/, 
                                  LPCSTR szWasResCodeInXml,
                                  nfc::CIkXMLDom * pDom)
{
	if(bSuccess)
	{
		if(ParseAndEventFire(pDom) == false)
			m_eError = wasError_Protocol;
	}

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseNoticeList(m_pActor, GetID(), m_eError, m_listNoticeData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}


void CWASListNotice::OnRequestTimeout(CHttpFacade * /*pHttpF*/, DWORD /*dwSeconds*/)
{
	m_eError = wasError_Timeout;

	GT_ASSERT(m_pActor);

	//CRITICAL_SECTION * pCS = m_pActor->GetCriticalSection();
	//EnterCriticalSection(pCS);

	CGTObserved<IGTWASActorEvent>::listobserver_t observers;
	m_pActor->GetObservers(&observers);
	CGTObserved<IGTWASActorEvent>::listobserver_t::iterator it = observers.begin();	

	for (; it != observers.end(); ++it)
		if((*it)->OnGTWASActor_ResponseNoticeList(m_pActor, GetID(), m_eError, m_listNoticeData) == false)
			break;

	//LeaveCriticalSection(pCS);

	if(m_pActor)
		m_pActor->ReleaseCommand(GetID());
}
